// **** BEGIN LICENSE BLOCK ****
// Copyright(c) 2008 Edoardo Gargano
//
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// Portions of this code have been based upon
// GDocsBar - http://www.gdocsbar.com
// Copyright (c) 2007, Sandosh Vasudevan.
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//
//
// segodoc.js - the utility file of SeGoDOc
//
// This program is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 of the License, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
// more details.
//
// You should have received a copy of the GNU General Public License along with
// this program; if not, write to the Free Software Foundation, Inc., 59 Temple
// Place, Suite 330, Boston, MA 02111-1307 USA
//
// **** END LICENSE BLOCK ****
var SegodocUtils = {};

/* SegodocUtils.preferences = new SegodocPreferences(); */

SegodocUtils.escapeValue = function(value) {
	// should we be putting +'s in for spaces?
	// if so we need to do it before escape
	// changes them into %20's
	return escape(value);
};

SegodocUtils.unescapeValue = function(value) {
	return unescape(value).replace(/\+/g, " ");
};

SegodocUtils.encode64 = function(value) {
	return btoa(value);
};

SegodocUtils.decode64 = function(value) {
	// in case the value is no good...
	try {
		return atob(value);
	} catch (e) {
		// that's too bad
		return value;
	}
};

SegodocUtils.HEX = "hex";
SegodocUtils.DECIMAL = "decimal";

SegodocUtils.hexHTMLValue = function(value) {
	return SegodocUtils.translate(value, SegodocUtils.HEX);
};

SegodocUtils.decimalHTMLValue = function(value) {
	return SegodocUtils.translate(value, SegodocUtils.DECIMAL);
};

SegodocUtils.unHTMLValue = function(value) {
	return SegodocUtils.untranslate(value);
};

SegodocUtils.translate = function(value, how) {
	var hex = (how == SegodocUtils.HEX);
	var newValue = "";
	for (var index = 0; index < value.length; index++) {
		var charcode = value.charCodeAt(index);
		newValue += "&#";
		if (hex) {
			newValue += "x";
			newValue += SegodocUtils.decimalToHex(charcode);
		} else {
			newValue += charcode;
		}
		newValue += ";";
	}
	return newValue;
};

SegodocUtils.untranslate = function(value) {
	var newValue = value;
	var noHex = '"'
			+ value.replace(/&#[X|x]([^&]*);/g,
					'" + String.fromCharCode(0x$1) + "') + '"';
	var nothing = noHex.replace(/&#([^&]*);/g,
			'" + String.fromCharCode($1) + "');
	newValue = eval(nothing);
	return newValue;
};

SegodocUtils.HEX_DIGITS = "0123456789ABCDEF";
SegodocUtils.decimalToHex = function(decimal) {
	var hex = SegodocUtils.HEX_DIGITS.substr(decimal & 15, 1);
	while (decimal > 15) {
		decimal >>= 4;
		hex = SegodocUtils.HEX_DIGITS.substr(decimal & 15, 1) + hex;
	}
	return hex;
};

SegodocUtils.log = function(message) {
	// if (SegodocUtils.preferences.isDebug()) {
	var consoleService = Components.classes["@mozilla.org/consoleservice;1"]
			.getService(Components.interfaces.nsIConsoleService);
	consoleService.logStringMessage("SegodocData: " + message);
//	SegodocUtils.myDump(message);
	// }
};

SegodocUtils.myDump= function(aMessage) {
	var consoleService = Components.classes["@mozilla.org/consoleservice;1"]
			.getService(Components.interfaces.nsIConsoleService);
	var now = new Date();
	var nowString = now.toUTCString();
//	consoleService.logStringMessage(nowString + "_LOG: " + aMessage + "\n");
	//document.getElementById("logging").value += nowString + "_LOG " + aMessage
	//		+ "\n";
	//str = "<b>"+nowString+"_LOG </b><br />"+"<pre>"+aMessage+"</pre>";
	str = nowString+"_LOG\n"+aMessage+"\n";
	fileName = "log.txt";
	SegodocUtils.writeFileLog(fileName,str);
}
SegodocUtils.httpLog= function(aMessage) {
	var consoleService = Components.classes["@mozilla.org/consoleservice;1"]
			.getService(Components.interfaces.nsIConsoleService);
	var now = new Date();
	var nowString = now.toUTCString();
//	consoleService.logStringMessage(nowString + "_LOG: " + aMessage + "\n");
	//document.getElementById("logging").value += nowString + "_LOG " + aMessage
	//		+ "\n";
	//str = "<b>"+nowString+"_LOG </b><br />"+"<pre>"+aMessage+"</pre>";
	str = nowString+"_LOG\n"+aMessage+"\n";
	fileName = "/home/cnt00/logHTTP.txt";
	SegodocUtils.writeFileLog(fileName,str);
}
SegodocUtils.writeFileLog= function(sFilePath, sFileContent) {
	try {
		var file = Components.classes["@mozilla.org/file/local;1"]
				.createInstance(Components.interfaces.nsILocalFile);
		file.QueryInterface(Components.interfaces.nsIFile);
		file.initWithPath(sFilePath);
		//if (file.exists() == true)
		//	file.remove(false);
		var strm = Components.classes["@mozilla.org/network/file-output-stream;1"]
				.createInstance(Components.interfaces.nsIFileOutputStream);
		strm.QueryInterface(Components.interfaces.nsIOutputStream);
		strm.QueryInterface(Components.interfaces.nsISeekableStream);
		strm.init(file, 0x02 | 0x08 | 0x10, 0666, 0); 
		strm.write(sFileContent, sFileContent.length);
		strm.flush();
		strm.close();
	} catch (ex) {
		
		window.alert(ex.message);
	}
}

SegodocUtils.loadFile = function(promptText) {
	var fp = Components.classes["@mozilla.org/filepicker;1"]
			.createInstance(Components.interfaces.nsIFilePicker);
	var stream = Components.classes["@mozilla.org/network/file-input-stream;1"]
			.createInstance(Components.interfaces.nsIFileInputStream);
	var streamIO = Components.classes["@mozilla.org/scriptableinputstream;1"]
			.createInstance(Components.interfaces.nsIScriptableInputStream);
	var validFile = false;

	fp.init(window, promptText, fp.modeOpen);
	fp.appendFilters(fp.filterText);

	var input;
	if (fp.show() != fp.returnCancel) {
		stream.init(fp.file, 0x01, 0444, null);
		streamIO.init(stream);
		input = streamIO.read(stream.available());
		streamIO.close();
		stream.close();
	}
	return input;
};


SegodocUtils.htmlEscape = function(string) {
	var espressione = new RegExp(/&lt;/g);
	var espressione2 = new RegExp(/&gt;/g);
	string=string.replace(espressione,"<").replace(espressione2,">");
	var espressione3 = new RegExp(/&quot;/g);
	var espressione4 = new RegExp(/&amp;/g);
	string=string.replace(espressione4,'&');
	return string;
};

SegodocUtils.writeFile = function(promptText, data) {
	var fp = Components.classes["@mozilla.org/filepicker;1"]
			.createInstance(Components.interfaces.nsIFilePicker);
	var stream = Components.classes["@mozilla.org/network/file-output-stream;1"]
			.createInstance(Components.interfaces.nsIFileOutputStream);

	fp.init(window, promptText, fp.modeSave);
	fp.appendFilters(fp.filterText);

	if (fp.show() != fp.returnCancel) {
		if (fp.file.exists()) {
			fp.file.remove(true);
		}
		fp.file.create(fp.file.NORMAL_FILE_TYPE, 0666);

		stream.init(fp.file, 0x02, 0x200, null);
		stream.write(data, data.length);
		stream.close();
	}
};

SegodocUtils.getTime = function(time) {
	var curr_hour = time.getHours();
	var curr_min = time.getMinutes();
	if (curr_min < 10) {
		curr_min = "0" + curr_min;
	}

	var curr_sec = time.getSeconds();
	if (curr_sec < 10) {
		curr_sec = "0" + curr_sec;
	}

	var curr_ms = time.getMilliseconds();
	if (curr_ms < 10) {
		curr_ms = "00" + curr_ms;
	} else if (curr_ms < 100) {
		curr_ms = "0" + curr_ms;
	}
	return curr_hour + ":" + curr_min + ":" + curr_sec + "." + curr_ms;
};

SegodocUtils.createStringInputStream = function(data) {
	var sis = Components.classes["@mozilla.org/io/string-input-stream;1"];
	var tmpStream = sis
			.createInstance(Components.interfaces.nsIStringInputStream);
	tmpStream.setData(data, data.length);
	tmpStream.QueryInterface(Components.interfaces.nsIInputStream);
	return tmpStream;
};

// e.g. z, "gzip",

SegodocUtils.uncompress = function(data, from) {
	var stream = SegodocUtils.createStringInputStream(data);
	return SegodocUtils.uncompressStream(stream, from);
};

SegodocUtils.uncompressStream = function(dataStream, from) {
	var className = "@mozilla.org/streamconv;1?from=" + from
			+ "&to=uncompressed";
	var converter = Components.classes[className]
			.createInstance(Components.interfaces.nsIStreamConverter);
	var listener = {
		data : "",
		onDataAvailable : function(request, context, stream, offset, count) {
			this.data = this.data + SegodocUtils.readAll(stream, true);
		},
		onStartRequest : function(request, context) {
		},
		onStopRequest : function(request, context, statusCode) {
		},
		QueryInterface : function(iid) {
			if (!iid.equals(Components.interfaces.nsISupports)
					&& !iid.equals(Components.interfaces.nsIStreamListener)
					&& !iid.equals(Components.interfaces.nsIRequestObserver)) {
				throw Components.results.NS_ERROR_NO_INTERFACE;
			}
			return this;
		}
	};

	// fake uri needed to create a channel
	var uri = Components.classes["@mozilla.org/network/simple-uri;1"]
			.createInstance(Components.interfaces.nsIURI);
	// uri.scheme = "http://gunzip";
	uri.scheme = "http";

	// fake channel needed to create a request
	var chan = Components.classes["@mozilla.org/network/input-stream-channel;1"]
			.createInstance(Components.interfaces.nsIInputStreamChannel);
	chan.QueryInterface(Components.interfaces.nsIChannel);
	chan.setURI(uri);
	chan.contentLength = -1;
	chan.contentType = from;
	chan.contentStream = null;

	var request = chan.QueryInterface(Components.interfaces.nsIRequest);
	if (converter.asyncConvertData) {
		// 1.5
		converter.asyncConvertData(from, "uncompressed", listener, null);
	} else {
		// < 1.5
		converter.AsyncConvertData(from, "uncompressed", listener, null);
	}
	converter.onStartRequest(request, null);
	try {
		converter.onDataAvailable(request, null, dataStream, 0, dataStream
						.available());
	} catch (e) {
		SegodocUtils.log("Caught an exception trying to convert: " + e);
	}
	converter.onStopRequest(request, null, {});
	return listener.data;
};

SegodocUtils.readAll = function(inputStream, raw) {
	var scriptableDataStream = SegodocUtils
			.createScriptableInputStream(inputStream);
	var data = "";
	if (raw) {
		var size = scriptableDataStream.available();
		for (var i = 0; i < size; i++) {
			var c = scriptableDataStream.read(1);
			c ? data += c : data += '\0';
		}
	} else {
		data = scriptableDataStream.read(scriptableDataStream.available());
	}
	scriptableDataStream.close();
	return data;
};

SegodocUtils.createScriptableInputStream = function(inputStream) {
	var stream = Components.classes["@mozilla.org/scriptableinputstream;1"]
			.createInstance(Components.interfaces.nsIScriptableInputStream);
	stream.init(inputStream);
	return stream;
};

SegodocUtils.copyToClipboard = function(text) {
	if (text) {
		try {
			const clipboardHelper = Components.classes["@mozilla.org/widget/clipboardhelper;1"]
					.getService(Components.interfaces.nsIClipboardHelper);
			clipboardHelper.copyString(text);
		} catch (e) {
			// that's too bad
		}
	}
};

SegodocUtils.testPassword = function(passwd) {
	var intScore = 0
	var strVerdict = "weak"
	var strLog = ""

	// PASSWORD LENGTH
	if (passwd.length < 5) // length 4 or less
	{
		intScore = (intScore + 3)
		strLog = strLog + "3 points for length (" + passwd.length + ")\n"
	} else if (passwd.length > 4 && passwd.length < 8) // length between 5 and
														// 7
	{
		intScore = (intScore + 6)
		strLog = strLog + "6 points for length (" + passwd.length + ")\n"
	} else if (passwd.length > 7 && passwd.length < 16)// length between 8 and
														// 15
	{
		intScore = (intScore + 12)
		strLog = strLog + "12 points for length (" + passwd.length + ")\n"
	} else if (passwd.length > 15) // length 16 or more
	{
		intScore = (intScore + 18)
		strLog = strLog + "18 point for length (" + passwd.length + ")\n"
	}

	// LETTERS (Not exactly implemented as dictacted above because of my limited
	// understanding of Regex)
	if (passwd.match(/[a-z]/)) // [verified] at least one lower case letter
	{
		intScore = (intScore + 1)
		strLog = strLog + "1 point for at least one lower case char\n"
	}

	if (passwd.match(/[A-Z]/)) // [verified] at least one upper case letter
	{
		intScore = (intScore + 5)
		strLog = strLog + "5 points for at least one upper case char\n"
	}

	// NUMBERS
	if (passwd.match(/\d+/)) // [verified] at least one number
	{
		intScore = (intScore + 5)
		strLog = strLog + "5 points for at least one number\n"
	}

	if (passwd.match(/(.*[0-9].*[0-9].*[0-9])/)) // [verified] at least three
													// numbers
	{
		intScore = (intScore + 5)
		strLog = strLog + "5 points for at least three numbers\n"
	}

	// SPECIAL CHAR
	if (passwd.match(/.[!,@,#,$,%,^,&,*,?,_,~]/)) // [verified] at least one
													// special character
	{
		intScore = (intScore + 5)
		strLog = strLog + "5 points for at least one special char\n"
	}

	// [verified] at least two special characters
	if (passwd.match(/(.*[!,@,#,$,%,^,&,*,?,_,~].*[!,@,#,$,%,^,&,*,?,_,~])/)) {
		intScore = (intScore + 5)
		strLog = strLog + "5 points for at least two special chars\n"
	}

	// COMBOS
	if (passwd.match(/([a-z].*[A-Z])|([A-Z].*[a-z])/)) // [verified] both upper
														// and lower case
	{
		intScore = (intScore + 2)
		strLog = strLog + "2 combo points for upper and lower letters\n"
	}

	if (passwd.match(/([a-zA-Z])/) && passwd.match(/([0-9])/)) // [verified]
																// both letters
																// and numbers
	{
		intScore = (intScore + 2)
		strLog = strLog + "2 combo points for letters and numbers\n"
	}

	// [verified] letters, numbers, and special characters
	if (passwd
			.match(/([a-zA-Z0-9].*[!,@,#,$,%,^,&,*,?,_,~])|([!,@,#,$,%,^,&,*,?,_,~].*[a-zA-Z0-9])/)) {
		intScore = (intScore + 2)
		strLog = strLog
				+ "2 combo points for letters, numbers and special chars\n"
	}

	if (intScore < 16) {
		strVerdict = "very weak";
		document.getElementById("colorMe").style.background = "red";
	} else if (intScore > 15 && intScore < 25) {
		strVerdict = "weak";
		document.getElementById("colorMe").style.background = "orange";
	} else if (intScore > 24 && intScore < 35) {
		strVerdict = "normal";
		document.getElementById("colorMe").style.background = "yellow";
	} else if (intScore > 34 && intScore < 45) {
		strVerdict = "strong";
		document.getElementById("colorMe").style.background = "green";
	} else {
		strVerdict = "stronger";
		document.getElementById("colorMe").style.background = "limeGreen";
	}
	// document.getElementById("score").value=intScore;
	// document.getElementById("verdict").value=strVerdict;
	// document.getElementById("matchlog").value=strLog;
	document.getElementById("colorMe").value = "   " + strVerdict;

	return intScore + " " + strVerdict;

}

SegodocUtils.convertAphostrophe = function(string) {

//	if( string.replace(/\W/,'') != string || !string ) { window.alert('The variable name you have chosen is invalid.\nIt may only contain characters a-z, A-Z, 0-9 and _'); return; }
	var tempVal = string;
	var fromAr = new Array(/\\/g,/'/g,/"/g,/\r\n/g,/[\r\n]/g,/\t/g,new RegExp('--'+'>','g'),new RegExp('<!'+'--','g'),/\//g), toAr = new Array('\\\\','\\\'','\\\"','\\n','\\n','\\t','--\'+\'>','<!\'+\'--','\\\/');
	for( var x = 0; x < fromAr.length; x++ ) {
		tempVal = tempVal.replace(fromAr[x],toAr[x]);
	}
	var quoteStyle = ('\'');
	tempVal = tempVal.replace(/&/g,'&amp;').replace(/<{1}/g,'&lt;').replace(/>/g,'&gt;').replace(/"/g,'&quot;');
	tempVal = tempVal.replace(/'/g,'&#39;');
	return tempVal;
}



/* Generate Secure Password cijfer = length, m = mode: 1 number 2 alfanumeric */
SegodocUtils.generatePass = function() {
	var m = 1; // alfanumeric
	var cijfer;
	var lengthPassIndex = document.getElementById("lengthPass-group").selectedIndex;
	if (lengthPassIndex == 0)
		cijfer = 8;
	if (lengthPassIndex == 1)
		cijfer = 16;
	if (lengthPassIndex == 2)
		cijfer = 32;
	if (!cijfer) {
		cijfer == "6"
	}
	if (m == "0") {
		var chars = "1234506789";
	}
	if (m == "1") {
		var chars = "^[_]!#$%&()<=>{}|?@*+-0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ~abcdefghijklmnopqrstuvwxyz";
	}
	if (m == "2") {
		var chars = "0123456789abcdef";
	}
	if (m == "3") {
		var chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
	}
	if (m == "4") {
		var chars = "101";
	} // No leading zero!
	if (m == "5") {
		var chars = "435XH781$xr!x0fORoi-+^@~|_|)(";
	}
	var pass = ""
	for (x = 0; x < cijfer; x++) {
		rand = Math.random() * chars.length;
		genn = Math.round(rand);
		while (genn <= 0) {
			genn++;
		}
		pass += chars.charAt(genn);
	}
	SegodocUtils.testPassword(document.getElementById("passAES").value);
	document.getElementById("passAES").value = pass;
//	SegodocUtils.log("Generated password " + pass);
	// return pass;
}

/**
* Function : dump()
* Arguments: The data - array,hash(associative array),object
*    The level - OPTIONAL
* Returns  : The textual representation of the array.
* This function was inspired by the print_r function of PHP.
* This will accept some data as the argument and return a
* text that will be a more readable version of the
* array/hash/object that is given.
*/
SegodocUtils.dump = function(arr,level) {
var dumped_text = "";
if(!level) level = 0;

//The padding given at the beginning of the line.
var level_padding = "";
for(var j=0;j<level+1;j++) level_padding += "    ";

if(typeof(arr) == 'object') { //Array/Hashes/Objects
 for(var item in arr) {
  var value = arr[item];
 
  if(typeof(value) == 'object') { //If it is an array,
   dumped_text += level_padding + "'" + item + "' ...\n";
   dumped_text += dump(value,level+1);
  } else {
   dumped_text += level_padding + "'" + item + "' => \"" + value + "\"\n";
  }
 }
} else { //Stings/Chars/Numbers etc.
 dumped_text = "===>"+arr+"<===("+typeof(arr)+")";
}
return dumped_text;
}